package io.dekorate.application.config;

import io.dekorate.project.Project;
import io.dekorate.kubernetes.config.ConfigKey;
import io.dekorate.kubernetes.config.Configuration;
import java.lang.Object;
import java.lang.String;
import java.util.Map;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.dekorate.deps.kubernetes.api.builder") public class ApplicationConfig extends Configuration{

    private String group = "";
    private String name = "";
    private String version = "";
    private io.dekorate.application.config.Contact[] owners = new io.dekorate.application.config.Contact[0];
    private io.dekorate.application.config.Contact[] maintainers = new io.dekorate.application.config.Contact[0];
    private io.dekorate.application.config.Info[] info = new io.dekorate.application.config.Info[0];
    private io.dekorate.application.config.Icon[] icons = new io.dekorate.application.config.Icon[0];
    private io.dekorate.application.config.Link[] links = new io.dekorate.application.config.Link[0];
    private String notes = "";
    private String[] keywords = new java.lang.String[0];

    public ApplicationConfig(){
    }
    public ApplicationConfig(Project project,Map<ConfigKey,Object> attributes,String group,String name,String version,io.dekorate.application.config.Contact[] owners,io.dekorate.application.config.Contact[] maintainers,io.dekorate.application.config.Info[] info,io.dekorate.application.config.Icon[] icons,io.dekorate.application.config.Link[] links,String notes,String[] keywords){
            super(project, attributes);
            this.group = group != null ? group : "";
            this.name = name != null ? name : "";
            this.version = version != null ? version : "";
            this.owners = owners != null ? owners : new io.dekorate.application.config.Contact[0];
            this.maintainers = maintainers != null ? maintainers : new io.dekorate.application.config.Contact[0];
            this.info = info != null ? info : new io.dekorate.application.config.Info[0];
            this.icons = icons != null ? icons : new io.dekorate.application.config.Icon[0];
            this.links = links != null ? links : new io.dekorate.application.config.Link[0];
            this.notes = notes != null ? notes : "";
            this.keywords = keywords != null ? keywords : new java.lang.String[0];
    }

    public String getGroup(){
            return this.group;
    }

    public String getName(){
            return this.name;
    }

    public String getVersion(){
            return this.version;
    }

    public io.dekorate.application.config.Contact[] getOwners(){
            return this.owners;
    }

    public io.dekorate.application.config.Contact[] getMaintainers(){
            return this.maintainers;
    }

    public io.dekorate.application.config.Info[] getInfo(){
            return this.info;
    }

    public io.dekorate.application.config.Icon[] getIcons(){
            return this.icons;
    }

    public io.dekorate.application.config.Link[] getLinks(){
            return this.links;
    }

    public String getNotes(){
            return this.notes;
    }

    public String[] getKeywords(){
            return this.keywords;
    }




}
