package io.dekorate.application.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import io.dekorate.kubernetes.config.ConfigurationFluent;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import java.lang.Deprecated;
import java.util.Iterator;
import java.lang.Boolean;
import io.dekorate.kubernetes.config.ConfigKey;
import io.dekorate.project.Project;
import java.lang.StringBuffer;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;

public interface ApplicationConfigFluent<A extends ApplicationConfigFluent<A>> extends ConfigurationFluent<A>{


    public String getGroup();
    public A withGroup(String group);
    public Boolean hasGroup();
    public A withNewGroup(String arg1);
    public A withNewGroup(StringBuilder arg1);
    public A withNewGroup(StringBuffer arg1);
    public String getName();
    public A withName(String name);
    public Boolean hasName();
    public A withNewName(String arg1);
    public A withNewName(StringBuilder arg1);
    public A withNewName(StringBuffer arg1);
    public String getVersion();
    public A withVersion(String version);
    public Boolean hasVersion();
    public A withNewVersion(String arg1);
    public A withNewVersion(StringBuilder arg1);
    public A withNewVersion(StringBuffer arg1);
    public A withOwners(io.dekorate.application.config.Contact... owners);
    
/**
 * This method has been deprecated, please use method buildOwners instead.
 */
@Deprecated public io.dekorate.application.config.Contact[] getOwners();
    public io.dekorate.application.config.Contact[] buildOwners();
    public io.dekorate.application.config.Contact buildOwner(int index);
    public io.dekorate.application.config.Contact buildFirstOwner();
    public io.dekorate.application.config.Contact buildLastOwner();
    public io.dekorate.application.config.Contact buildMatchingOwner(io.dekorate.deps.kubernetes.api.builder.Predicate<ContactBuilder> predicate);
    public Boolean hasMatchingOwner(io.dekorate.deps.kubernetes.api.builder.Predicate<ContactBuilder> predicate);
    public A addToOwners(int index,io.dekorate.application.config.Contact item);
    public A setToOwners(int index,io.dekorate.application.config.Contact item);
    public A addToOwners(io.dekorate.application.config.Contact... items);
    public A addAllToOwners(Collection<io.dekorate.application.config.Contact> items);
    public A removeFromOwners(io.dekorate.application.config.Contact... items);
    public A removeAllFromOwners(Collection<io.dekorate.application.config.Contact> items);
    public A removeMatchingFromOwners(io.dekorate.deps.kubernetes.api.builder.Predicate<ContactBuilder> predicate);
    public Boolean hasOwners();
    public A addNewOwner(String name,String email,String url);
    public ApplicationConfigFluent.OwnersNested<A> addNewOwner();
    public ApplicationConfigFluent.OwnersNested<A> addNewOwnerLike(io.dekorate.application.config.Contact item);
    public ApplicationConfigFluent.OwnersNested<A> setNewOwnerLike(int index,io.dekorate.application.config.Contact item);
    public ApplicationConfigFluent.OwnersNested<A> editOwner(int index);
    public ApplicationConfigFluent.OwnersNested<A> editFirstOwner();
    public ApplicationConfigFluent.OwnersNested<A> editLastOwner();
    public ApplicationConfigFluent.OwnersNested<A> editMatchingOwner(io.dekorate.deps.kubernetes.api.builder.Predicate<ContactBuilder> predicate);
    public A withMaintainers(io.dekorate.application.config.Contact... maintainers);
    
/**
 * This method has been deprecated, please use method buildMaintainers instead.
 */
@Deprecated public io.dekorate.application.config.Contact[] getMaintainers();
    public io.dekorate.application.config.Contact[] buildMaintainers();
    public io.dekorate.application.config.Contact buildMaintainer(int index);
    public io.dekorate.application.config.Contact buildFirstMaintainer();
    public io.dekorate.application.config.Contact buildLastMaintainer();
    public io.dekorate.application.config.Contact buildMatchingMaintainer(io.dekorate.deps.kubernetes.api.builder.Predicate<ContactBuilder> predicate);
    public Boolean hasMatchingMaintainer(io.dekorate.deps.kubernetes.api.builder.Predicate<ContactBuilder> predicate);
    public A addToMaintainers(int index,io.dekorate.application.config.Contact item);
    public A setToMaintainers(int index,io.dekorate.application.config.Contact item);
    public A addToMaintainers(io.dekorate.application.config.Contact... items);
    public A addAllToMaintainers(Collection<io.dekorate.application.config.Contact> items);
    public A removeFromMaintainers(io.dekorate.application.config.Contact... items);
    public A removeAllFromMaintainers(Collection<io.dekorate.application.config.Contact> items);
    public A removeMatchingFromMaintainers(io.dekorate.deps.kubernetes.api.builder.Predicate<ContactBuilder> predicate);
    public Boolean hasMaintainers();
    public A addNewMaintainer(String name,String email,String url);
    public ApplicationConfigFluent.MaintainersNested<A> addNewMaintainer();
    public ApplicationConfigFluent.MaintainersNested<A> addNewMaintainerLike(io.dekorate.application.config.Contact item);
    public ApplicationConfigFluent.MaintainersNested<A> setNewMaintainerLike(int index,io.dekorate.application.config.Contact item);
    public ApplicationConfigFluent.MaintainersNested<A> editMaintainer(int index);
    public ApplicationConfigFluent.MaintainersNested<A> editFirstMaintainer();
    public ApplicationConfigFluent.MaintainersNested<A> editLastMaintainer();
    public ApplicationConfigFluent.MaintainersNested<A> editMatchingMaintainer(io.dekorate.deps.kubernetes.api.builder.Predicate<ContactBuilder> predicate);
    public A withInfo(io.dekorate.application.config.Info... info);
    
/**
 * This method has been deprecated, please use method buildInfo instead.
 */
@Deprecated public io.dekorate.application.config.Info[] getInfo();
    public io.dekorate.application.config.Info[] buildInfo();
    public io.dekorate.application.config.Info buildInfo(int index);
    public io.dekorate.application.config.Info buildFirstInfo();
    public io.dekorate.application.config.Info buildLastInfo();
    public io.dekorate.application.config.Info buildMatchingInfo(io.dekorate.deps.kubernetes.api.builder.Predicate<InfoBuilder> predicate);
    public Boolean hasMatchingInfo(io.dekorate.deps.kubernetes.api.builder.Predicate<InfoBuilder> predicate);
    public A addToInfo(int index,io.dekorate.application.config.Info item);
    public A setToInfo(int index,io.dekorate.application.config.Info item);
    public A addToInfo(io.dekorate.application.config.Info... items);
    public A addAllToInfo(Collection<io.dekorate.application.config.Info> items);
    public A removeFromInfo(io.dekorate.application.config.Info... items);
    public A removeAllFromInfo(Collection<io.dekorate.application.config.Info> items);
    public A removeMatchingFromInfo(io.dekorate.deps.kubernetes.api.builder.Predicate<InfoBuilder> predicate);
    public Boolean hasInfo();
    public A addNewInfo(String name,String value,String type,String valueFrom);
    public ApplicationConfigFluent.InfoNested<A> addNewInfo();
    public ApplicationConfigFluent.InfoNested<A> addNewInfoLike(io.dekorate.application.config.Info item);
    public ApplicationConfigFluent.InfoNested<A> setNewInfoLike(int index,io.dekorate.application.config.Info item);
    public ApplicationConfigFluent.InfoNested<A> editInfo(int index);
    public ApplicationConfigFluent.InfoNested<A> editFirstInfo();
    public ApplicationConfigFluent.InfoNested<A> editLastInfo();
    public ApplicationConfigFluent.InfoNested<A> editMatchingInfo(io.dekorate.deps.kubernetes.api.builder.Predicate<InfoBuilder> predicate);
    public A withIcons(io.dekorate.application.config.Icon... icons);
    
/**
 * This method has been deprecated, please use method buildIcons instead.
 */
@Deprecated public io.dekorate.application.config.Icon[] getIcons();
    public io.dekorate.application.config.Icon[] buildIcons();
    public io.dekorate.application.config.Icon buildIcon(int index);
    public io.dekorate.application.config.Icon buildFirstIcon();
    public io.dekorate.application.config.Icon buildLastIcon();
    public io.dekorate.application.config.Icon buildMatchingIcon(io.dekorate.deps.kubernetes.api.builder.Predicate<IconBuilder> predicate);
    public Boolean hasMatchingIcon(io.dekorate.deps.kubernetes.api.builder.Predicate<IconBuilder> predicate);
    public A addToIcons(int index,io.dekorate.application.config.Icon item);
    public A setToIcons(int index,io.dekorate.application.config.Icon item);
    public A addToIcons(io.dekorate.application.config.Icon... items);
    public A addAllToIcons(Collection<io.dekorate.application.config.Icon> items);
    public A removeFromIcons(io.dekorate.application.config.Icon... items);
    public A removeAllFromIcons(Collection<io.dekorate.application.config.Icon> items);
    public A removeMatchingFromIcons(io.dekorate.deps.kubernetes.api.builder.Predicate<IconBuilder> predicate);
    public Boolean hasIcons();
    public A addNewIcon(String type,String src,String size);
    public ApplicationConfigFluent.IconsNested<A> addNewIcon();
    public ApplicationConfigFluent.IconsNested<A> addNewIconLike(io.dekorate.application.config.Icon item);
    public ApplicationConfigFluent.IconsNested<A> setNewIconLike(int index,io.dekorate.application.config.Icon item);
    public ApplicationConfigFluent.IconsNested<A> editIcon(int index);
    public ApplicationConfigFluent.IconsNested<A> editFirstIcon();
    public ApplicationConfigFluent.IconsNested<A> editLastIcon();
    public ApplicationConfigFluent.IconsNested<A> editMatchingIcon(io.dekorate.deps.kubernetes.api.builder.Predicate<IconBuilder> predicate);
    public A withLinks(io.dekorate.application.config.Link... links);
    
/**
 * This method has been deprecated, please use method buildLinks instead.
 */
@Deprecated public io.dekorate.application.config.Link[] getLinks();
    public io.dekorate.application.config.Link[] buildLinks();
    public io.dekorate.application.config.Link buildLink(int index);
    public io.dekorate.application.config.Link buildFirstLink();
    public io.dekorate.application.config.Link buildLastLink();
    public io.dekorate.application.config.Link buildMatchingLink(io.dekorate.deps.kubernetes.api.builder.Predicate<LinkBuilder> predicate);
    public Boolean hasMatchingLink(io.dekorate.deps.kubernetes.api.builder.Predicate<LinkBuilder> predicate);
    public A addToLinks(int index,io.dekorate.application.config.Link item);
    public A setToLinks(int index,io.dekorate.application.config.Link item);
    public A addToLinks(io.dekorate.application.config.Link... items);
    public A addAllToLinks(Collection<io.dekorate.application.config.Link> items);
    public A removeFromLinks(io.dekorate.application.config.Link... items);
    public A removeAllFromLinks(Collection<io.dekorate.application.config.Link> items);
    public A removeMatchingFromLinks(io.dekorate.deps.kubernetes.api.builder.Predicate<LinkBuilder> predicate);
    public Boolean hasLinks();
    public A addNewLink(String description,String url);
    public ApplicationConfigFluent.LinksNested<A> addNewLink();
    public ApplicationConfigFluent.LinksNested<A> addNewLinkLike(io.dekorate.application.config.Link item);
    public ApplicationConfigFluent.LinksNested<A> setNewLinkLike(int index,io.dekorate.application.config.Link item);
    public ApplicationConfigFluent.LinksNested<A> editLink(int index);
    public ApplicationConfigFluent.LinksNested<A> editFirstLink();
    public ApplicationConfigFluent.LinksNested<A> editLastLink();
    public ApplicationConfigFluent.LinksNested<A> editMatchingLink(io.dekorate.deps.kubernetes.api.builder.Predicate<LinkBuilder> predicate);
    public String getNotes();
    public A withNotes(String notes);
    public Boolean hasNotes();
    public A withNewNotes(String arg1);
    public A withNewNotes(StringBuilder arg1);
    public A withNewNotes(StringBuffer arg1);
    public A withKeywords(String... keywords);
    public String[] getKeywords();
    public A addToKeywords(int index,String item);
    public A setToKeywords(int index,String item);
    public A addToKeywords(String... items);
    public A addAllToKeywords(Collection<String> items);
    public A removeFromKeywords(String... items);
    public A removeAllFromKeywords(Collection<String> items);
    public Boolean hasKeywords();
    public A addNewKeyword(String arg1);
    public A addNewKeyword(StringBuilder arg1);
    public A addNewKeyword(StringBuffer arg1);

    public interface OwnersNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,ContactFluent<ApplicationConfigFluent.OwnersNested<N>>{

        
    public N and();    public N endOwner();
}
    public interface MaintainersNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,ContactFluent<ApplicationConfigFluent.MaintainersNested<N>>{

        
    public N and();    public N endMaintainer();
}
    public interface InfoNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,InfoFluent<ApplicationConfigFluent.InfoNested<N>>{

        
    public N and();    public N endInfo();
}
    public interface IconsNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,IconFluent<ApplicationConfigFluent.IconsNested<N>>{

        
    public N and();    public N endIcon();
}
    public interface LinksNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,LinkFluent<ApplicationConfigFluent.LinksNested<N>>{

        
    public N and();    public N endLink();
}


}
