package io.dekorate.application.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class IconBuilder extends IconFluentImpl<IconBuilder> implements VisitableBuilder<io.dekorate.application.config.Icon,IconBuilder>{

    IconFluent<?> fluent;
    Boolean validationEnabled;

    public IconBuilder(){
            this(true);
    }
    public IconBuilder(Boolean validationEnabled){
            this(new Icon(), validationEnabled);
    }
    public IconBuilder(IconFluent<?> fluent){
            this(fluent, true);
    }
    public IconBuilder(IconFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new Icon(), validationEnabled);
    }
    public IconBuilder(IconFluent<?> fluent,io.dekorate.application.config.Icon instance){
            this(fluent, instance, true);
    }
    public IconBuilder(IconFluent<?> fluent,io.dekorate.application.config.Icon instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withType(instance.getType()); 
            fluent.withSrc(instance.getSrc()); 
            fluent.withSize(instance.getSize()); 
            this.validationEnabled = validationEnabled; 
    }
    public IconBuilder(io.dekorate.application.config.Icon instance){
            this(instance,true);
    }
    public IconBuilder(io.dekorate.application.config.Icon instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withType(instance.getType()); 
            this.withSrc(instance.getSrc()); 
            this.withSize(instance.getSize()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableIcon build(){
            EditableIcon buildable = new EditableIcon(fluent.getType(),fluent.getSrc(),fluent.getSize());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            IconBuilder that = (IconBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
