package io.dekorate.application.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class LinkBuilder extends LinkFluentImpl<LinkBuilder> implements VisitableBuilder<io.dekorate.application.config.Link,LinkBuilder>{

    LinkFluent<?> fluent;
    Boolean validationEnabled;

    public LinkBuilder(){
            this(true);
    }
    public LinkBuilder(Boolean validationEnabled){
            this(new Link(), validationEnabled);
    }
    public LinkBuilder(LinkFluent<?> fluent){
            this(fluent, true);
    }
    public LinkBuilder(LinkFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new Link(), validationEnabled);
    }
    public LinkBuilder(LinkFluent<?> fluent,io.dekorate.application.config.Link instance){
            this(fluent, instance, true);
    }
    public LinkBuilder(LinkFluent<?> fluent,io.dekorate.application.config.Link instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withDescription(instance.getDescription()); 
            fluent.withUrl(instance.getUrl()); 
            this.validationEnabled = validationEnabled; 
    }
    public LinkBuilder(io.dekorate.application.config.Link instance){
            this(instance,true);
    }
    public LinkBuilder(io.dekorate.application.config.Link instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withDescription(instance.getDescription()); 
            this.withUrl(instance.getUrl()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableLink build(){
            EditableLink buildable = new EditableLink(fluent.getDescription(),fluent.getUrl());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            LinkBuilder that = (LinkBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
